"use strict";
this.name = "coluber_hud_ch01";
this.author = "Captain Beatnik captain.beatnik@gmx.de, Norby norbylite@gmail.com";
this.licence = "CC BY-NC-SA 4.0";

this.startUp = function () {
	player.ship.hud =  this.name + "-dock.plist";
	var h = worldScripts.hudselector;
	if( h ) h.$HUDSelectorAddHUD("Coluber HUD CH01", this.name);
}

this.shipWillDockWithStation = function(station) {
	player.ship.hud =  this.name + "-dock.plist";
	if( this.$Timer ) { this.$Timer.stop(); delete this.$Timer;}
}

this.shipWillLaunchFromStation = function() {
	player.ship.hud =  this.name + ".plist";
	if( !this.$Timer ) this.$Timer = new Timer(this, this._update.bind(this), 0, 0.25);
}

this.$HUDSelectorCallBack = function ( off ) {
	var w = worldScripts.coluber_hud_ch01;
	if( off ) { //do things to disable your HUD like rename functions
		if( w.shipWillDockWithStation ) {
			w.$save_shipWillDockWithStation = w.shipWillDockWithStation;
			delete w.shipWillDockWithStation;
		}
		if( w.shipWillLaunchFromStation ) {
			w.$save_shipWillLaunchFromStation = w.shipWillLaunchFromStation;
			delete w.shipWillLaunchFromStation;
		}
		if( w.$Timer ) { w.$Timer.stop(); delete w.$Timer;}
	} else { //do things to activate your HUD like restore disabled functions
		//  if the player is docked, use the docked version of the HUD
		if (player.ship.docked) player.ship.hud =  this.name + "-dock.plist";
		if( !w.shipWillLaunchFromStation ) {
			eval("w.shipWillDockWithStation = "+w.$save_shipWillDockWithStation);
			eval("w.shipWillLaunchFromStation = "+w.$save_shipWillLaunchFromStation);
		}
		if( !this.$Timer ) this.$Timer = new Timer(this, this._update.bind(this), 0, 0.25);
	}
}

this._centeredText = function(txt, width) {
	var t = ""+txt; //force to srting, else txt.length is undefined for numbers
	var w = width / 2;
	while( t && t.length < w ) { //for fixed with font in setCustomHUDDial
		t = " " + t;
	}
	return(t);
}

this._update = function () {
	var p = player.ship;
	if( !p || !p.isValid ) return; //player died

	var setd = p.setCustomHUDDial;
	if( setd ) {
		if( !worldScripts.combat_MFD ) { //prefer CombatMFD if available
			var sp = Math.round(p.velocity.magnitude()/10)*10;
			sp = this._centeredText(sp, 28); //default width
			setd("combatSpeed", sp);
		}
	
		//altimeter
		var c = system.sun; //closest planetary object
       		if( c ) var d = p.position.distanceTo( c.position );
		else var d = 100000000000000000000.0; //10^20m for sure
		var l = system.planets;
		var len = l.length;
		for( var i = 0; i < len; i++ ) { //find the smallest distance
			var s = p.position.distanceTo( l[i].position )-l[i].radius;
			if( d > s ) {
				d = s;
				c = l[i];
			}
		}
		var alt = ""; //clear if no planetary object
		if( c ) {
			var a = p.position.distanceTo(c) - c.radius - p.collisionRadius;
			if( a < 1000 ) alt = this._centeredText( Math.floor(a)+"m", 28 );
		}
		setd("nearAlt", alt);
	}
}
